package streams;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Main {

	public static void main(String[] args) {
		Student obai = new Student("obai","mannheim","informatik");
		Pruefung pr = new Pruefung("TE2", 10,2,1.4);
		
		obai.addPruefung(pr);
		
		Student omar = new Student("obai","mannheim","Cyber");
		Pruefung pr2 = new Pruefung("PR2", 12,1,5);
		omar.addPruefung(pr2);
		
		ArrayList<Student> sts = new ArrayList<>();
		sts.add(omar);
		sts.add(obai);
		
//		//Alle Studenten eines bestimmten Studiengangs ausgeben
//		sts.stream()
//		.filter(stg -> stg.getStudiengang().equals("informatik"))
//		.forEach(i -> System.out.println(i.getName()));
//		
//		//Notenschnitt jeder Studi-Instanz berechnen und ausgeben
//		sts.stream()
//		.flatMap(st -> st.getPruefungen().stream())
//		.forEach(System.out::println);
//		
//		
//		 sts.forEach(student -> {
//	            double durchschnitt = student.getPruefungen().stream()
//	                    .mapToDouble(Pruefung::getNote)
//	                    .average()
//	                    .orElse(Double.NaN); // Optional: um NaN zu vermeiden, falls keine Prüfungen vorhanden sind
//	            System.out.println("Durchschnittsnote von " + student.getName() + ": " + durchschnitt);
//	        });
		
		 //Alle Studenten ausgeben, die eine Prüfung nicht bestanden haben
		 sts.stream()
		 .flatMap(p -> p.getPruefungen().stream())
		 .filter(n -> n.getNote() >= 5)
		 .forEach(student -> System.out.println("Student: " + student.getName()));
	}

}
class Student {
    private String name;
    private String wohnort;
    private String studiengang;
    private ArrayList<Pruefung> pruefungen;

    public Student(String name, String wohnort, String studiengang) {
        this.name = name;
        this.wohnort = wohnort;
        this.studiengang = studiengang;
        this.pruefungen = new ArrayList<>();
    }

    // Methoden zum Hinzufügen einer Prüfung
    public void addPruefung(Pruefung pruefung) {
        pruefungen.add(pruefung);
    }

    // Getter und Setter
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getWohnort() {
        return wohnort;
    }

    public void setWohnort(String wohnort) {
        this.wohnort = wohnort;
    }

    public String getStudiengang() {
        return studiengang;
    }

    public void setStudiengang(String studiengang) {
        this.studiengang = studiengang;
    }

    public ArrayList<Pruefung> getPruefungen() {
        return pruefungen;
    }

    @Override
    public String toString() {
        return "Student{" +
                "name='" + name + '\'' +
                ", wohnort='" + wohnort + '\'' +
                ", studiengang='" + studiengang + '\'' +
                ", pruefungen=" + pruefungen +
                '}';
    }
}


class Pruefung {
    private String name;
    private int ectsZahl;
    private int semester;
    private double note;

    public Pruefung(String name, int ectsZahl, int semester, double note) {
        this.name = name;
        this.ectsZahl = ectsZahl;
        this.semester = semester;
        this.note = note;
    }

    // Getter und Setter
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getEctsZahl() {
        return ectsZahl;
    }

    public void setEctsZahl(int ectsZahl) {
        this.ectsZahl = ectsZahl;
    }

    public int getSemester() {
        return semester;
    }

    public void setSemester(int semester) {
        this.semester = semester;
    }

    public double getNote() {
        return note;
    }

    public void setNote(double note) {
        this.note = note;
    }

    @Override
    public String toString() {
        return "Pruefung{" +
                "name='" + name + '\'' +
                ", ectsZahl=" + ectsZahl +
                ", semester=" + semester +
                ", note=" + note +
                '}';
    }
}

